#include <conio.h>
#include <iostream.h>
#include <stdio.h>
#include <stdlib.h>
#include <mem.h>
#include <fstream.h>
#include <math.h>
#include <time.h>
#define MAX_X 320
#define MAX_Y 200
#define uchar unsigned char
#define uint unsigned int
#define MAX_DEEP 3
#define OBJS 10
#define TRACE_FLAG 1
#define LABEL_FRAMES 100
#define LABEL_MAX 100

uchar far *screen = (unsigned char far*)0xa0000000l;
uchar far virt[64001];
unsigned char far dither_tab[1024];
struct color {
	uint value;
	uint alpha;
	};
struct sprite {
	uchar resx;
	uchar resy;
	uchar* buff;
	};

void init_dither_tab(void)
{
	for (int x=0;x<1024;x++)
		dither_tab[x] = random(4);
}

void do_dither(void)
{
		int x,y;
		unsigned char input;
		int dither_tab_lookup = random(1024);
		for (y=0;y<200;y++)
			{
			for (x=0;x<320;x++)
				{
				input = virt[y*320 + x];
				if ((dither_tab[dither_tab_lookup]>(input % 4)) ||
					(input > 250))
//				if (random(4) > input%4)
//				if (1 == 1)
					input = input >> 2;
				else
					input = (input >> 2) + 1;
				virt[y*320 + x] = input << 2;
				dither_tab_lookup++;
				if (dither_tab_lookup == 1024) dither_tab_lookup = 0;
				}
			}
}

sprite get_file_sprite(char filename[], int resx, int resy)
	{
	FILE *stream;
	int x,y;
	unsigned char input;
	sprite temp_sprite;
	temp_sprite.resx = resx;
	temp_sprite.resy = resy;
	temp_sprite.buff = (uchar *)malloc(resx*resy);

	if ((stream = fopen(filename, "rb")) != NULL)
		{
		for (y=0;y<resy;y++)
			{
			for (x=0;x<resx;x++)
				{
				input = (fgetc(stream) & 0xFF);
				temp_sprite.buff[y*temp_sprite.resx +x] = input;
				}
			}
		}
	return temp_sprite;
	}

sprite make_box(void)
	{
	sprite my_sprite;
	my_sprite.resx=16;
	my_sprite.resy=16;
	my_sprite.buff = (uchar *)malloc(256);
	for (int i=0; i<256; i++) my_sprite.buff[i] = 254;
	return my_sprite;
	}

sprite make_ball(void)
	{
	sprite my_sprite;
	my_sprite.resx=4;
	my_sprite.resy=4;
	int radius = my_sprite.resx>>1;
	my_sprite.buff = (uchar *)malloc(256);
	for (int i=0; i<my_sprite.resx; i++)
		{
		for (int j=0; j<my_sprite.resy; j++)
			{
			if ((((i-radius)*(i-radius) + (j-radius)*(j-radius))/radius)<radius)
				my_sprite.buff[j*my_sprite.resx+i] = 100;
			else
				my_sprite.buff[j*my_sprite.resx+i] = 255;
			}
		}
	return my_sprite;
	}

void setmode(short mode)
	{
	asm mov ax, mode;
	asm int 0x10;
	}

void greyscale(void)
{
	for (int x=0;x<256;x++)
		{
		outportb(0x3c8,x);
		outportb(0x3c9,x >> 2);
		outportb(0x3c9,x >> 2);
		outportb(0x3c9,x >> 2);
		}
}

color sample_line(int x1, int y1, int x2, int y2,
						int deep, sprite spr, int &total)
	{
	color temp_color, get1, get2;
	temp_color.value = 0;
	temp_color.alpha = 0;
	if (deep>MAX_DEEP) return temp_color;
	int x=(x1+x2)>>1;
	int y=(y1+y2)>>1;
	if (((x==x1)&&(y==y1))||((x==x2)&&(y==y2))) return temp_color;
	if ((x>=0)&&(y>=0)&&
		(x<spr.resx)&&(y<spr.resy)&&
		(spr.buff[y*spr.resx+x]<255))
		{
		temp_color.alpha=1;
		temp_color.value=spr.buff[y*spr.resx+x];
		}
	total++;
	get1 = sample_line(x1,y1,x,y,deep+1,spr,total);
	get2 = sample_line(x,y,x2,y2,deep+1,spr,total);
	temp_color.alpha+=get1.alpha + get2.alpha;
	temp_color.value+=get1.value + get2.value;
	return temp_color;
	}

int draw_sprite(int x, int y, sprite spr, uchar far *virt)
	{
	int minx, miny, maxx, maxy;
	int i, j, x1, y1;
	minx = x;
	maxx = x+spr.resx;
	miny = y;
	maxy = y+spr.resy;
	if (minx<0) minx=0;
	if (miny<0) miny=0;
	if (maxx>MAX_X) maxx = MAX_X;
	if (maxy>MAX_Y) maxy = MAX_Y;
	for (j=miny; j<maxy; j++)
		{
		y1 = j-y;
		for (i=minx; i<maxx; i++)
			{
			x1 = i-x;
			if ((x1>=0)&&(x1<spr.resx)&&
				(y1>=0)&&(y1<spr.resy)&&
				(spr.buff[y1*spr.resx+x1]<255))
				virt[j*MAX_X+i] = spr.buff[y1*spr.resx+x1];
			}
		}
	return 0;
	}

void WaitRetrace() {

	_DX = 0x03DA;

	l1: asm {
		in  al,dx;
		and al,0x08;
		jnz l1;
		}

	l2: asm {
		in  al,dx;
		and al,0x08;
		jz  l2;
		}
	}

int mblur_sprite(int x, int y, int dx, int dy, int alpha, sprite spr, uchar far *virt)
	{
	color temp_color;
	dx = dx>>1; dy=dy>>1;
	int minx, miny, maxx, maxy, i, j;
	int x1, y1, x2, y2, total;
	uchar col;
	if (abs(dx)<1 && abs(dy)<1) return draw_sprite(x,y,spr,virt);

	minx = x-dx;
	maxx = x+dx;
	miny = y-dy;
	maxy = y+dy;
	if (minx>maxx)
		{
		minx ^= maxx;
		maxx ^= minx;
		minx ^= maxx;
		}
	if (miny>maxy)
		{
		miny ^= maxy;
		maxy ^= miny;
		miny ^= maxy;
		}
	maxx += spr.resx;
	maxy += spr.resy;
	if (minx<0) minx=0;
	if (miny<0) miny=0;
	if (maxx>MAX_X) maxx = MAX_X;
	if (maxy>MAX_Y) maxy = MAX_Y;
	if ((maxx==minx)||(maxy==miny)) return 0;
	for (j=miny; j<maxy; j++)
		{
		y1=j-dy-y;
		y2=j+dy-y;
		for (i=minx; i<maxx; i++)
			{
			x1=i-dx-x;
			x2=i+dx-x;
			total=0;
			temp_color = sample_line(x1,y1,x2,y2,0,spr,total);
			if (temp_color.alpha>0) {
				temp_color.value /= temp_color.alpha;
				temp_color.alpha = (temp_color.alpha*alpha)/total;
				col = virt[j*MAX_X+i];
				col = (temp_color.value*temp_color.alpha +
						 col*(255-temp_color.alpha))/255;
				virt[j*MAX_X+i] = col;
				}
			if(total==0) i=maxx; //just a little time saver
			}
		}
	return 0;
	}

void handle_label(sprite my_label, int global_k, uchar far *virt)
	{
	//initialization
	static int k;
	static int draw_mode;
	int dx, dy, posx, posy, alpha;
	if (global_k ==0) k = 0;
	if (global_k ==0) draw_mode=0;
	posx = 320 - my_label.resx -10;
	posy = 200 - my_label.resy -7;
	//Hosekeeping
	if (k==LABEL_FRAMES)
		{
		k=0;
		draw_mode++;
		if (draw_mode==4) draw_mode=0;
		}
	//handle fadeup
	dy = 0;
	if (draw_mode==1)
		{
		dx = ((LABEL_FRAMES-k)*LABEL_MAX)/LABEL_FRAMES;
		alpha = (k*255)/LABEL_FRAMES;
		mblur_sprite(posx, posy, dx, dy, alpha, my_label, virt);
		}
	//handle hold
	if (draw_mode==2)
		{
		dx = 0;
		mblur_sprite(posx, posy, dx, dy, 255, my_label, virt);
		k--;
		}
	//handle fadedown
	if (draw_mode==3)
		{
		dx = 0;
		dy = (k*LABEL_MAX)/LABEL_FRAMES;
		alpha = ((LABEL_FRAMES-k)*255)/LABEL_FRAMES;
		mblur_sprite(posx, posy, dx, dy, alpha, my_label, virt);
		}
	k++;
	}

void checker_back(uchar far* virt, int k)
	{
	int x,y,xx,yy;
	uint indexer=0;
	for (y=0;y<200;y++)
		{
		for (x=0;x<320;x++)
			{
			xx=(x+k)/40;
			yy=(y+k)/40;
			if ((xx%2+yy%2)%2==0) virt[indexer]=0;
			else virt[indexer]=16;
			indexer++;
			}
		}
	}

void tile_back(uchar far *virt, int k, sprite background)
	{
	int x,y;
	int resx, resy, samplex, sampley;
	uint indexer = 40*320;
	resx = background.resx;
	resy = background.resy;
	for (y=40; y<160; y++)
		{
		for (x=0;x<320; x++)
			{
			samplex = (x+k)%(resx-1);
			sampley = (y+k)%(resy-1);
			virt[indexer] = background.buff[sampley*resx +samplex];
			indexer++;
			}
		}
	}

void test_animation(void)
	{
	sprite box= get_file_sprite("ball.raw",16,16);
	sprite my_label= get_file_sprite("maus.raw",100,25);
	sprite background= get_file_sprite("kitchen.raw",64,64);
	sprite smallbox = make_ball();
	int x[OBJS], y[OBJS], oldx[OBJS], oldy[OBJS], k, i;
	int xx[32], yy[32], oldxx[32], oldyy[32];
	k=0;
	for (i=0;i<OBJS;i++) {oldx[i]=0; oldy[i]=0;}
	for (i=0;i<32;i++) {oldxx[i]=0; oldyy[i]=0;}
	while (!kbhit())
		{
		_fmemset(virt, 0, 64000);
		tile_back(virt, k, background);
		handle_label(my_label,k,virt);
		for (i=0; i<32; i++)
			{
			xx[i] = i*10 +5;
			yy[i] = 50*sin((10*i+k)/5.0) +100;
			mblur_sprite((oldxx[i]+xx[i])>>1, (oldyy[i]+yy[i])>>1, xx[i]-oldxx[i], yy[i]-oldyy[i], 255, smallbox, virt);
			oldxx[i] = xx[i];
			oldyy[i] = yy[i];
			}
		for (i=0; i<OBJS; i++)
			{
			x[i] = 150 * sin((k+i/2)/(float)((i%10)+4)) + 152;
			y[i] = 90 * cos((k+i/2)/(float)((i%10)+5)) + 92;
			mblur_sprite((oldx[i]+x[i])>>1, (oldy[i]+y[i])>>1, x[i]-oldx[i],y[i]-oldy[i],255,box,virt);
			oldx[i] = x[i];
			oldy[i] = y[i];
			}
		do_dither();
		for (i=0; i<TRACE_FLAG; i++) WaitRetrace();
		_fmemcpy(screen, virt,64001);
		k++;
		}
	}

int main(void)
	{
	init_dither_tab();
	setmode (0x13);
	greyscale();
	test_animation();
	setmode (0x03);
	return 0;
	}

